// Converts raw data from ff14-fish-tracker to JSON files that we can use with serde.
// The only thing that manually needs to be done is to export the variables from said files.
// Run using `node convert-to-json.js`.

import { DATA } from "./data.js";
import { FISH_INFO } from "./fish_data.js";
import fs from "node:fs/promises";

const result = {
  db_data: DATA,
  fish_entries: FISH_INFO,
};

// For some reason, there are sometimes double-nested `bestCatchPath` attributes?
Object.values(result.db_data.FISH).forEach((fish) => {
  if (fish.bestCatchPath[0] instanceof Array) {
    result.db_data.FISH[fish._id].bestCatchPath = fish.bestCatchPath[0];
  }
});

const json = JSON.stringify(result);

await fs.writeFile("data.json", json, { encoding: "utf8" });
