// Mostly nicked from https://github.com/icykoneko/ff14-fish-tracker-app/blob/master/js/app/time.js. Thanks!

use chrono::{DateTime, Utc};

const EARTH_TO_EORZEA: f64 = 3600. / 175.;
const EORZEA_TO_EARTH: f64 = 1. / EARTH_TO_EORZEA;

pub fn to_eorzea_time(earth_time: DateTime<Utc>) -> DateTime<Utc> {
    let et_ts = earth_time.timestamp();
    let new_ts = et_ts.abs() as f64 * EARTH_TO_EORZEA;
    DateTime::from_timestamp(new_ts.floor() as i64, 0).unwrap()
}

pub fn get_current_eorzea_date() -> DateTime<Utc> {
    to_eorzea_time(Utc::now())
}

pub fn to_earth_time(ez_time: DateTime<Utc>) -> DateTime<Utc> {
    let ez_ts = ez_time.timestamp();
    let new_ts = (ez_ts.abs() as f64 * EORZEA_TO_EARTH).ceil();
    DateTime::from_timestamp(new_ts as i64, 0).unwrap()
}
